﻿<?php

class Todo {
	private $db;
	private $database;
	
	function __construct() {
		$this->database = 'todo';
		// Adatbázis létrehozása, ha még eddig nem volt.
		// A PDO segíatségével nem lehet létrehozni adatbázist, ezért kell a mysql függvényeit használnunk.
		$this->createMysqlDatabase();
		try {
			// Kapcsolódás az adatbázishoz.
			$this->db = new PDO("mysql:host=localhost;dbname=$this->database", 'root', '');
		} catch (PDOException $e) {
			print 'Hiba:' . $e->getMessage();
		}
	}
	
	/**
	 * Adatbázis létrehozása.
	 */
	private function createMysqlDatabase() {
		$mysqlConnection = mysql_connect('localhost', 'root', '') or die('Nem sikerült csatlakozni az adatbázishoz.');
		if (!mysql_select_db($this->database)) {
			mysql_query("CREATE DATABASE `$this->database` DEFAULT CHARACTER SET utf8 COLLATE utf8_hungarian_ci;");
			mysql_query($this->getDbSchema());
		}
	}
	
	private function getDbSchema() {
		// file_get_contents segítségével beolvashatjuk a fájl teljes tartalmát.
		// Így megspórolhatjuk az fopen(), fgets() és fclose() hívásokat.
		$sql = file_get_contents('install.sql');
		return $sql;
	}
	
	public function save($todo) {
		try {
			$todo['title'] = htmlspecialchars($todo['title']);
			$todo['description'] = htmlspecialchars($todo['description']);
			// Prepared statement. Többször felhasználható kérés.
			$insert = $this->db->prepare("INSERT INTO `todolist` (title, description, deadline) VALUES (:title, :description, :deadline)");
			// Paraméterek hozzácsatolása változókhoz. A típust is megadhatjuk.
			$insert->bindParam(':title', $todo['title'], PDO::PARAM_STR);
			$insert->bindParam(':description', $todo['description'], PDO::PARAM_STR);
			$insert->bindParam(':deadline', mktime(0, 0, 0, $todo['deadline']['month'], $todo['deadline']['day'], $todo['deadline']['year']), PDO::PARAM_INT);
			// Kérés lefuttatása.
			$insert->execute();
		} catch (PDOException $e) {
			print 'Hiba:' . $e->getMessage();
		}
	}
	
	public function getAllTodos() {
		// Lekérdezés futtatása az adatbázisoon.
		$todos = $this->db->query("SELECT * FROM `todolist`");
		// Az eredmény egy PDOStatement. foreach segítségével bejárható.
		return $todos;
	}
	
	public function getTodo($id) {
		if (!is_numeric($id)) {
			return NULL;
		}
		// Prepared statment SELECT előkészítésére.
		$todo = $this->db->prepare("SELECT * FROM `todolist` WHERE id = :id ORDER BY deadline");
		$todo->execute(array(':id' => $id));
		// egy sor lekérése fetch() segítségével.
		return $todo->fetch();
	}
	
	public function exportTodos() {
		// TODO
	}
	
	function __desctruct() {
		// Kapcoslat lezárása
		$this->db =  NULL;
	}
	
	
}

?>
